Value - Crystal 1.11.2

# abstract struct Value

- Value
- Object

##
Overview

`Value` is the base type of the primitive types (`Nil`, `Bool`, `Char`, `Number`), `Symbol`, `Pointer`, `Tuple`, `StaticArray` and all structs.

A `Value` is passed by value: when you pass it to methods, return it from methods or assign it to variables, a copy of the value is actually passed. This is not important for nil, bools, integers, floats, symbols, pointers and tuples, because they are immutable, but with a mutable `Struct` or with a `StaticArray` you have to be careful. Read their documentation to learn more about this.

##
Direct Known Subclasses

- Bool
- Char
- Class
- Enum
- NamedTuple(**T)
- Nil
- Number
- Pointer(T)
- Proc(*T, R)
- StaticArray(T, N)
- Struct
- Symbol
- Tuple(*T)
- Union(*T)

##
Defined in:

json/any.cr
value.cr
yaml/any.cr

##
Instance Method Summary

- #==(other : JSON::Any)
- #==(other : YAML::Any)
- #==(other)

  Returns `false`.

- #dup

  Returns a shallow copy of this object.

### Instance methods inherited from class `Object`

! : Bool !, !=(other) !=, !~(other) !~, ==(other) ==, ===(other : JSON::Any)
===(other : YAML::Any)
===(other) ===, =~(other) =~, as(type : Class) as, as?(type : Class) as?, class class, dup dup, hash(hasher)
hash hash, in?(collection : Object) : Bool
in?(*values : Object) : Bool in?, inspect(io : IO) : Nil
inspect : String inspect, is_a?(type : Class) : Bool is_a?, itself itself, nil? : Bool nil?, not_nil!(message)
not_nil! not_nil!, pretty_inspect(width = 79, newline = "\n", indent = 0) : String pretty_inspect, pretty_print(pp : PrettyPrint) : Nil pretty_print, responds_to?(name : Symbol) : Bool responds_to?, tap(&) tap, to_json(io : IO) : Nil
to_json : String to_json, to_pretty_json(indent : String = " ") : String
to_pretty_json(io : IO, indent : String = " ") : Nil to_pretty_json, to_s(io : IO) : Nil
to_s : String to_s, to_yaml(io : IO) : Nil
to_yaml : String to_yaml, try(&) try, unsafe_as(type : T.class) forall T unsafe_as

### Class methods inherited from class `Object`

from_json(string_or_io, root : String)
from_json(string_or_io) from_json, from_yaml(string_or_io : String | IO) from_yaml

### Macros inherited from class `Object`

class_getter(*names, &block) class_getter, class_getter!(*names) class_getter!, class_getter?(*names, &block) class_getter?, class_property(*names, &block) class_property, class_property!(*names) class_property!, class_property?(*names, &block) class_property?, class_setter(*names) class_setter, def_clone def_clone, def_equals(*fields) def_equals, def_equals_and_hash(*fields) def_equals_and_hash, def_hash(*fields) def_hash, delegate(*methods, to object) delegate, forward_missing_to(delegate) forward_missing_to, getter(*names, &block) getter, getter!(*names) getter!, getter?(*names, &block) getter?, property(*names, &block) property, property!(*names) property!, property?(*names, &block) property?, setter(*names) setter

##
Instance Method Detail

def ==(other : JSON::Any) #
def ==(other : YAML::Any) #
def ==(other) #

Returns `false`.

def dup #

Returns a shallow copy of this object.

Because `Value` is a value type, this method returns `self`, which already involves a shallow copy of this object because value types are passed by value.